
#include <string.h>
#include <openssl/evp.h>

#include "hash.h"

/* result must have HASH_SIZE bytes */
/* returns 1 for success, 0 for error */
/* implements SHA512 */
static EVP_MD_CTX sha512_ctx;
static const EVP_MD * sha512 = NULL;
int allnet_hash (char * data, int dsize, char * result)
{
  if (sha512 == NULL) {
    OpenSSL_add_all_digests ();  /* supposedly required */
    sha512 = EVP_get_digestbyname ("sha512");
    if (EVP_MD_size (sha512) != HASH_SIZE) {
      printf ("error: expected hash result size is %d, %d expected\n",
              EVP_MD_size (sha512), HASH_SIZE);
      return 0;
    }
  }
  EVP_DigestInit (&sha512_ctx, sha512);
  EVP_DigestUpdate (&sha512_ctx, data, dsize);
  unsigned int result_size;
  EVP_DigestFinal (&sha512_ctx, result, &result_size);
  if (result_size != HASH_SIZE)
    printf ("error: hash result size is %ud, %d expected\n",
            result_size, HASH_SIZE);
  return 1;
}

int allnet_hash_part (char * data, int dsize, char * result, int rsize)
{
  if (rsize >= HASH_SIZE)
    return allnet_hash (data, dsize, result);
  char real_hash [HASH_SIZE];
  int r = allnet_hash (data, dsize, real_hash);
  if (r != 0)
    memcpy (result, real_hash, rsize);
  return r;
}
