/* hash.h: function to compute a hash of a collection of bytes */
/* uses SHA512 */

#ifndef ALLNET_HASH_H
#define ALLNET_HASH_H

#define HASH_SIZE	64	/* SHA 512 hashes are 512 bits or 64 bytes */

/* result must have HASH_SIZE bytes */
/* returns 1 for success, 0 for error */
extern int allnet_hash (char * data, int dsize, char * result);

/* only fill in the first rsize bytes of result.  Normally, rsize < HASH_SIZE,
 * but this works either way */
extern int allnet_hash_part (char * data, int dsize, char * result, int rsize);

#endif /* ALLNET_HASH_H*/
