#ifndef WTXRXD_H
#define WTXRXD_H

/* The protocol for communicating with allnetd is simple:
 * for any received message, give allnetd MAGIC_MESSAGE followed by
 *  by the message
 * when we are ready for the next batch of data, give allnetd MAGIC_SENT
 *  followed by 64-bit byte count we may be able to send
 * get from allnetd MAGIC_DATA followed by the number of messages being
 *  sent, then the number of bytes that follow, then bytes worth of
 *  messages, sorted in descending order of priority
 * at the beginning, send to allnetd a MAGIC_INIT followed by a single
 *  byte name length, then the name of the interface to use
 */

#define MAGIC_MESSAGE	"magicmsg"
#define MAGIC_SENT	"mgicsent"
#define MAGIC_DATA	"magidata"
#define MAGIC_INIT	"magcinit"
#define MAGIC_SIZE	(sizeof (MAGIC_MESSAGE) - 1)

#define ALLNETD_PROGRAM    "allnetd"
#define ALLNETD_PATH       "/home/esb/src/allnet/allnetd"
#define ALLNETD_PID        "/var/run/allnetd.pid"
#define ALLNETD_LOG        "/var/log/allnetd"

#define ALLNETD_PIPE_READ	3	/* fd for reading from pipe */
#define ALLNETD_PIPE_WRITE	4      	/* fd for writing to pipe */

#endif /* WTXRXD_H */
